=== debian/changelog ===
scipy (1.10.1-2) unstable; urgency=medium

  * Team upload.
  * armhf with openblas: skip test_L3
    test_svd_return_singular_vectors[shape1-True]
    test_m_gt_n test_pteqr test_SR1_skip_update
    test_symmetric_starting_vector
  * hppa: skip test_bootstrap_against_theory (not enough memory)
  * x32: skip test_sample (test_qmc.py)

 -- Drew Parsons <dparsons@debian.org>  Wed, 01 Mar 2023 15:41:11 +0100

scipy (1.10.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - bug fixes and stability improvements.
      Upload for bookworm (Bug#1032073).
    - applies debian patches
      find_cython3.patch
      fix_cast_PR17726.patch
      fix_highs_atomic_PR17777.patch
      pythran_type_PR16646.patch
      readonly_interpolate_PR17717.patch
  * allow optional VERSION argument for debian/get-submodules
    gbp import-orig, for instance, needs the submodule source to be
    already downloaded (before reported in debian/changelog).
    Submodule source is generated strictly for the indicated version
    if the git tag v$VERSION is available, otherwise git HEAD is used.
    - document submodule handling in debian/README.source.
    - note that get-submodules requires rsync
  * debian/copyright: add entry for submodules/scipy/_lib/boost
    License: Boost-1.0, 2008 John Maddock (boost/math) and other
    contributors. scipy only uses boost/math, the submodule will be
    simplified to booth_math in the future (upstream PR#17432).
  * x32: skip test_random_generator during build
  * riscv64 with atlas: skip runtime test test_aligned_mem
  * debian patch docs_privacy.patch deactivates net analytics sent to
    views.scientific-python.org. The site itself respects privacy, but
    traffic monitoring in the middle might breach privacy.
  * some dataset tests require internet: test_existence_all
    test_ascent test_face test_electrocardiogram.
    Run them separately in debian/tests/python3-network.

 -- Drew Parsons <dparsons@debian.org>  Tue, 28 Feb 2023 22:38:09 +0100

scipy (1.10.0-12) unstable; urgency=medium

  * Team upload.
  * x32: skip test_bounds during build
  * armhf with openblas: skip intermittently failing tests
    test_random_complex_exact test_L7 test_sygst
    test_various_drivers_standard test_various_drivers_generalized
    test_broyden1 test_broyden2 test_gejsv_general
    test_BFGS_skip_update test_tolerance_float32

 -- Drew Parsons <dparsons@debian.org>  Sat, 18 Feb 2023 16:12:32 +0100

scipy (1.10.0-11) unstable; urgency=medium

  * Team upload.
  * x32: skip test_1sample during build
  * armhf with openblas: skip more failing tests.
    test_tpqrt_tpmqrt test_cossin_separate test_orcsd_uncsd
    test_eigs_consistency[20-0.001] test_random_initial_float32
    test_pdist_out test_lsqr_basic test_pascal test_atol_rtol

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Feb 2023 22:45:22 +0100

scipy (1.10.0-10) unstable; urgency=medium

  * Team upload.
  * x32: skip test_0sample during build
  * armhf with openblas: arch is flaky, tests fail intermittently.
    Skip test_cdist_out test_cdist_calling_conventions
    test_orcsd_uncsd[float64] test_L1 test_L4
    test_random_exact test_random_tall_left test_random_tall_right
    test_svd_random_state_2[random_state test_svd_random_state_3
    test_svd_linop test_ElasticRod
    test_small_sigma_sparse[float32-shape1] test_small_sigma2[float]
    test_interpolation_misfit_1d test_svds_parameter_k_which[LM-5]
    test_Small test_failure_to_run_iterations
    test_precond_inverse[case1] test_examples
  * Consider using armhf with atlas or blis, not openblas.

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Feb 2023 10:34:17 +0100

scipy (1.10.0-9) unstable; urgency=medium

  * Team upload.
  * x32: skip test_0dim during build
  * armhf with openblas: skip failing sparse.linalg runtime tests
    eigen/lobpcg: test_MikotaPair test_diagonal[100-4-3] test_maxit
    eigen/svds: test_svd_random_state_3[random_state*
    isolve: test_precond_inverse[case1]
    propack: test_examples

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 Feb 2023 19:36:32 +0100
