=== debian/control ===
--- 
+++ 
@@ -5,8 +5,7 @@
            Varun Hiremath <varun@debian.org>
 Section: python
 Priority: optional
-Build-Depends: cython3 (>= 0.29.21~),
-               cython3 (<< 3.0),
+Build-Depends: cython3-legacy,
                debhelper-compat (= 13),
                dh-sequence-python3,
                pybuild-plugin-pyproject,
@@ -15,18 +14,18 @@
                liblapack-dev,
                liblbfgsb-dev,
                libsuitesparse-dev,
-               python3-mesonpy,
-               pkg-config,
+               python3-mesonpy (>= 0.12.1~),
+               pkgconf,
                python3-all-dev,
                python3-decorator,
-               python3-numpy (>= 1:1.21.4),
+               python3-doit (>= 0.35~) <!nocheck>,
+               python3-numpy (>= 1:1.21.6~),
                python3-pooch,
-               python3-pybind11 (>= 2.4.3),
+               python3-pybind11 (>= 2.10.4~),
                python3-pytest,
                python3-setuptools,
                python3-wheel,
-               python3-pythran,
-               python3-pythran (<< 0.13) [!armhf]
+               python3-pythran (>= 0.12.0~)
 Build-Depends-Indep: dvipng,
                      dh-sequence-sphinxdoc,
                      python3-doc,
@@ -35,7 +34,7 @@
                      python3-numpydoc,
                      python3-pydata-sphinx-theme,
                      python3-sphinx,
-                     python3-sphinx-panels,
+                     python3-sphinx-design,
                      python3-sphinx-tabs,
                      rdfind,
                      symlinks,
@@ -52,7 +51,6 @@
 Multi-Arch: foreign
 Depends: python3-decorator,
          python3-numpy (>= 1:1.17.3~),
-         python3-pythran [!armhf],
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
